<script type="text/javascript">
	function doInject(node, customMsg) {
		//console.log(`doInject: ${customMsg}`);
		//console.log(`doInject: ${JSON.stringify(customMsg)}`);
		$.ajax({
			url: "xkeys_savebacklights_inject/" + node.id,
			type: "POST",
			data: JSON.stringify(customMsg),
			contentType: "application/json; charset=utf-8"
		});
	}
    RED.nodes.registerType('xkeys_savebacklights',{
        category: 'Xkeys',
        color: '#5dc8f4',
        defaults: {
            newname: {value:"X-keys Save Backlights"},
            name: {value:""},
			pidOptions: {value: []},        // Property for user selected devices
			quad_list: {value: [],
				validate:function(v){
					return (v && v.length == 1);
				}
			},
			valid_target:{value:true},
        },
		button: {
			onclick: function() {
				// Called when the button is clicked
				//console.log(`click`);

				// Post device details to js to execute
				doInject(this, {payload:{ quad_list: this.quad_list}});
			},
			visible: function() {
				return (this.valid_target);
			}
		},
        inputs:0,
        outputs:0,
        icon: "X-keysXicon.png",
        label: function() {
            return this.name||this.newname||"X-keys Save Backlights";
        },
		labelStyle: function () {
			return this.newname?"node_label_italic":"";
		},
		paletteLabel: "xk Save BL",
		align: 'right',
		oneditprepare: function() {
			const parentDiv =  $("#dialog-form"); // <<make sure this selects YOUR nodes DIV
			var inputNo = 1;
			$.getJSON('xkeys_savebacklights/devices', function(device_data) {
				//console.log(`device_data: ${JSON.stringify(device_data)}`);
				var devs = device_data.devices;
				var pidOptions = device_data.pidOptions;
				var quad_list = device_data.quad_list;
				if (devs.length == 0) {
					//console.log(`No devices`);

					var myNewRow = $('<div class="form-row" />');
					parentDiv.append(myNewRow);
					var myNewLabel = $(`<label for="node-input-advice"><i class="fa fa-exclamation-circle"></i> Suggestion!</label>`);
					var myNewInput = $(`<input type="text" id="node-input-advice" placeholder="Press Deploy button to see available devices"/>`);
					myNewRow.append(myNewLabel);
					myNewRow.append(myNewInput);

					return;
				}
				devs.forEach( (device) => {
					//console.log(`Setting up: ${device.name}`);

					var inputID = "node-input-savebacklights-dynamic-" + inputNo; // for generating dynamic ID
					var myNewRow = $('<div class="form-row" />');
					parentDiv.append(myNewRow);
					var myNewInput = $(`<input type="checkbox" class="savebacklights-dynamic-element" id="${inputID}" style="width:64px;" data-quad="${device.device_quad}" data-name="${device.name}" />`);
					var myNewLabel = $(`<label for="${inputID}" style="width:360px;"><i class="fa fa-globe"></i> ${device.device_quad},  ${device.name}</label>`);
					myNewRow.append(myNewLabel);
					myNewRow.append(myNewInput);

					// If this device was seen previously (same device_quad), set its 'checked' status
					var matchedInputID = pidOptions.find((entry) => entry.device_quad == device.device_quad);
					if (matchedInputID) {
						$(`#${inputID}`).prop('checked', matchedInputID.checked);
					}

					inputNo++;
				});
			});
		},
		oneditsave: function () {
			// Construct label based on configured options
			this.newname = "X-keys Save Backlights";

			var dynamicElements = $(".savebacklights-dynamic-element");  // same class name as used for the dynamic DOM elements above
			var dynOpts = [];
			var quadList = [];dynamicElements.each( function(index,el) {
				var name = $(el).data("name"); //get value of data-name from the dynamic element
				var device_quad = $(el).data("quad"); //get value of data-device_quad from the dynamic element
				var checked = $(el).is(":checked"); //get checked true/false from the dynamic element
				var opt = {
					name: name,
					device_quad: device_quad,
					checked: checked
				}
				dynOpts.push(opt);
				if (checked) { quadList.push(device_quad); }
			});
			this.pidOptions = dynOpts; //update the node prop `pidOptions`
			this.quad_list = quadList;

			/* Warn of potential problems
			*/
			const sins = [];
			if (quadList.length == 0) {
				console.log(`No device selected`);
				sins.push("<br>No device has been selected. Please select an available device.<br>");
			} else if (!(quadList.length == 1)) {
				console.log(`Multiple devices selected`);
				sins.push("<br>Only a single device should be selected. Please select 1 only.<br>");
			}
			if (quadList.length == 1) {
				this.newname = dynOpts.find( (dev) => dev.device_quad == quadList[0]).name + " Save Backlights";
			}

			if (sins.length > 0) {
				this.valid_target = false;
				var notify_text = "";
				sins.forEach( (line) => {
					notify_text += line;
				});
				var myNotification = RED.notify( notify_text, {
					modal: true,
					fixed: true,
					type: 'warning',
					buttons: [
						{
							text: RED._("common.label.ok"),
							click: function(e) {
								myNotification.close();
							}
						}
					]
				});
			} else {
				this.valid_target = true;
			}
		}
    });
</script>


<script type="text/html" data-template-name="xkeys_savebacklights">
    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Label</label>
        <input type="text" id="node-input-name" placeholder="Auto">
    </div>
</script>

<script type="text/html" data-help-name="xkeys_savebacklights">
    <p>A node to save backlight setup of xkeys devices</p>
</script>


